'* Build As Console!
Superstrict
SeedRnd( Millisecs() )

Apptitle="Pirat-O-mat"

Global LF:String="~n"
Global in:String=""

Repeat
	Print("Willkommen zu ~q"+Apptitle+"~q - dem einfachen Weg, Piraten zu erzeugen!")
	Print("Wähle eine Variante:")
	Print("(*) Einen zufälligen Piraten erzeugen")
	Print("(Q) Beenden")
	in = input(":> ")
	Print("")
	Select in.tolower()
		Case "q"
			input("-ende-")
			end
	EndSelect

	Local P:TPirate = TPirate.Create()
	Print( P.toString() )

	Print("")
	Print("Piraten Speichern?")
	Print("(*) Naa")
	Print("(y) Yeah!")
	in = input(":> ")
	Print("")
	Select in.tolower()
		Case "y"
			P.Save( currentDate().replace(" ", "_") )
	EndSelect

Forever

Type TPirate 
	Field FirstName:String, LastName:String
	Field Nick:String
	Field Sex:Byte

							'* Eigenschaften (0-99)
	Field Courage:Byte 		'* Mut 
	Field Strength:Byte 	'* Stärke
	Field Agility:Byte 		'* Geschick
	Field Charisma:Byte 	'* Charisma
	Field Luck:Byte 		'* Glück

Rem
	Field Health:Int 		'* Gesundheit
	Field Scars:Int 		'* Narben
	Field Sailing:Int
	Field Mutiny:Int
	Field Trasure:Int
	Field Bloodlust:Int
	Field Tattoo:Int
	Field Parrots:Int
	Field Fencing:Int
	Field Voodoo:Int
EndRem

	Field Mother:String
	Field Father:String
	Field Fears:String
	Field Fights:String
	Field Crew:String
	Field Children:String
	Field Treasure:String

	Function Create:TPirate()
		Local o:TPirate = new TPirate
			o.RndProps()
			o.RndSex()
			o.RndName()
			o.RndParents()
			o.RndFears()
			o.RndCrew()
			o.RndFights()
			o.RndChildren()
		return o
	EndFunction

	Method RndProps()
		self.Courage 	= rand(0,99)
		self.Strength 	= rand(0,99)
		self.Agility 	= rand(0,99)
		self.Charisma 	= rand(0,99)
		self.Luck 		= rand(0,99)
	EndMethod

	Method RndSex()
		'* true=M, false=W
		if ( PercentRoll( 90 ) )
			self.Sex = true
		Else
			self.Sex = false
		endif
	EndMethod

	Method RndName()
		Global fn:String[][] = [["Alice", "Blanch", "Carolyn", "Dolores", "Elaine", "Francesca", "Glenda", "Hylda", "Isabella", "Jean", "Kathrine", "Leonore", "Marcie", "Natalia", "Olivia", "Penelope", "Renate", "Sally", "Tiffany", "Ursa", "Valery", "Wendy", "Yvette", "Zoe"], ..
								["Aron", "Barry", "Carlos", "Darryl", "Eric", "Floyd", "Guybrush", "Hugh", "Irving", "John", "Kenny", "Lancelot", "Milton", "Nelson", "Oswald", "Perry", "Randy", "Seymour", "Terrence", "Urias", "Vincent", "Wilson", "Zach"]]
		self.FirstName = fn[ self.Sex ][ Rand( 0, fn[self.Sex].length-1 ) ]

		Global nick_verb:String[] = ["", "Evil", "Enraged", "Vile", "Cruel", "Sad", "Fast", "Unbroken", "Lost", "Nutty", "Long", "Short"]
		Global nick_color:String[] = ["", "Red", "Black", "Blue", "Green", "Gold", "Grey", "Silver", "Crimson"]
		Global nick_thing:String[] = ["Beard", "Whale", "Master", "Sailor", "Danger", "Digger", "Smuggler", "Bastard", "Lord", "Executioner", "Slave", "Doom", "Water", "Wind", "Hero", "Serpent", "Lightning", "Hook", "Captain", "Dancer"]
		self.Nick = "The "+RndA(nick_verb)+" "+RndA(nick_color)+" "+RndA(nick_thing)
		RemoveDoubleSpace( self.Nick )

		Global ln:String[] = ["Smith", "Johnson", "Williams", "Jones", "Brown", "Davis", "Miller", "Wilson", "Moore", "Taylor", "Anderson", "Thomas", "Jackson", "White", "Harris", "Martin", "Thompson", "Garcia", "Martinez", "Robinson", "Clark", "Rodriguez", "Lewis", "Lee", "Walker", "Hall", "Allen", "Young", "Hernandez", "King", "Wright", "Lopez", "Hill", "Scott", "Green", "Adams", "Baker", "Gonzalez", "Nelson", "Carter", "Threepwood", "Rhodan"]
		self.LastName = RndA(ln)
	EndMethod

	Method RndParents()
		Global Mjob:String[] = ["Prostituierte", "Hure", "Hafennutte", "Dirne", "Bordsteinschwalbe", "Wäscherin", "Kerzendreherin", "Magd", "Lady"]
		self.Mother = "Deine Mutter war eine "+ RndA(Mjob)+ LF

		Global Fjob:String[] = ["Pirat", "Matrose", "Hafenarbeiter", "Schreiner", "Koch", "Bauer", "Gastwirt", "Lord"]
		self.Father = "Dein Vater war ein "+ RndA(Fjob)+ LF
	EndMethod

	Method RndFears()
		Local fears:String[] = ["Geistern", "Ratten", "Katzen", "Blut", "Spinnen", "Voodoo", "großer Höhe"]
		'* Anzahl: Courage
		Local n:Int = (100 - self.Courage) / 10
		local min_f:Int = 0
		if (self.Courage < 10) min_f = 1
		if (self.Courage > 95) n = 0
		Local r:Int = Rand(Min(min_f, n), Max(min_f, n))
		if (r = 0) then
			self.Fears = "Du fürchtest weder Tod noch Teufel"+LF
		Else
			self.Fears = "Du fürchtest dich vor "
			
			For Local i:Int = 0 Until r
				if (r>1 AND i>0 AND i=r-1) then
					self.Fears :+ " und "
				elseif (r>1 AND i>0 AND i<r)
					self.Fears :+ ", "
				endif

				Local f:Int = Rand(0, fears.length-1)
				self.Fears :+ fears[f]
				fears = fears[..f] + fears[f + 1..]
				if (fears.length = 0) exit
			Next
			self.Fears:+LF
		endif
	EndMethod

	Method RndFights()
		Global ort:String[] = ["in einer Bar", "bei einer Meuterei", "wärend eines Überfalls", "gegen Piratenjäger", "beim handwerken"]
		Global kpt:String[] = ["ein Finger", "zwei Finger", "drei Finger", "eine Hand", "einen Arm", "ein Bein"]
		'* Anzahl Kämpfe
		local r:Int = 90, c:Int=0, t:Int=1
		While ( PercentRoll(r) )
			r = LimitInt(r-10, self.Courage, 90)
			c:+1
			t:+1

			Local v:Int = 100-((self.Strength + self.Agility) / 2)
			Fights :+ "In deinem "+c+". Kampf "+ RndA(ort) +" "
			if ( PercentRoll(v) ) then
				if ( PercentRoll(self.Luck) ) then
					Fights :+ "erhältst du eine Narbe."+LF
				Else
					Fights :+ "verlierst du "+RndA(kpt)+LF
				endif
			Else
				Fights :+ "bekommst du nicht einen Kratzer ab."+LF
				t:+2
			endif
		Wend
		if (c=0) then
			Fights = "Du hast nie eine bedeutende Schlacht geschlagen."+LF
		endif

		Local g:Int
		While (t>0)
			g:+Rand(10*t,100*t)+t
			t:-1
		Wend
		Treasure = "Du besitzt einen Schatz von "+g+" Goldstücken"+LF			
	EndMethod

	Method RndChildren()
		local r:Int = (self.Charisma + self.Luck) / 2, c:Int=0
		While ( PercentRoll(r) )
			c:+1
		Wend
		if (c = 0)
			Children = "Du zeugst keine Kinder."
		elseif ( c = 1)
			Children = "Du zeugst ein Kind."
		Else
			Children = "Du zeugst "+c+" Kinder."
		endif
		Children:+LF
	EndMethod

	Method RndCrew()
		'* Anzahl: Charisma, Courage
		local r:Int = (self.Charisma + self.Courage) / 2, c:Int=Rand(4, 120)
		While ( PercentRoll(r) )
			c:+Rand(4, 120)
		Wend
		Crew = "Du befehligste eine Crew von "+c+" Mann."+LF
	EndMethod

	Method Save( _pathextra:String )
		Local file:String = self.LastName+"_"+_pathextra+".txt"
		local stream:TStream = WriteFile( file )
		if (stream = null) then
			Print("~nKonnte keine Datei schreiben! Schade!~n"+file+"~n")
			return
		endif

		stream.WriteLine( "Erstellt am: "+currentDate()+" um "+currenttime() )
		stream.WriteLine("")
		stream.WriteLine( self.toString() )

		stream.close()

		Print( "~q"+file+"~q gespeichert" )
	EndMethod

	Method toString:String()
		Local result:String
		Local Break:String=StringRe("=", 64)+LF

		result :+ Break
		result :+ self.FirstName+" ~q"+self.Nick+"~q "+self.LastName+LF
		result :+ Break
		result :+ "Mut:~t~t"+ PropToString(self.Courage) + LF
		result :+ "Stärke:~t"+ PropToString(self.Strength) + LF
		result :+ "Geschick:~t"+ PropToString(self.Agility) + LF
		result :+ "Charisma:~t"+ PropToString(self.Charisma) + LF
		result :+ "Glück:~t"+ PropToString(self.Luck) + LF
		result :+ Break
		result :+ self.Mother
		result :+ self.Father
		result :+ Break
		result :+ self.Fears
		result :+ self.Crew
		result :+ self.Fights
		result :+ self.Treasure
		result :+ self.Children
		result :+ Break

		return result
	EndMethod

EndType

Function RndA:String( _a:String[] )
	return _a[ Rand(0, _a.length-1) ]
EndFunction

Function PropToString:String( _v:Byte )
	Local result:String

	if ( _v = 0 ) result = "nicht vorhanden"
	if ( _v > 0 AND _v <= 5 ) result = "Blamabel"
	if ( _v > 5 AND _v <= 15 ) result = "Weniger"
	if ( _v > 15 AND _v <= 25 ) result = "Wenig"
	if ( _v > 25 AND _v <= 35 ) result = "Gering"
	if ( _v > 35 AND _v <= 45 ) result = "Unterdurchschnittlich"
	if ( _v > 45 AND _v <= 55 ) result = "Durchschnittlich"
	if ( _v > 55 AND _v <= 65 ) result = "Überdurchschnittlich"
	if ( _v > 65 AND _v <= 75 ) result = "Beeindruckend"
	if ( _v > 75 AND _v <= 85 ) result = "Legendär"
	if ( _v > 85 AND _v <= 95 ) result = "Übermenschlich"
	if ( _v > 95 ) result = "Gottgleich"

	return result +" ("+_v+"%)"
EndFunction

Function StringRe:String ( _s:String="=", _n:Int=1 )
	if (_s.length = 0) return _s
	if (_n <= 1) return _s
	Local result:String
	For Local i:Int = 0 until _n
		result:+_s
	Next
	return result
EndFunction

Function RemoveDoubleSpace( _s:String var)
	While ( _s.find("  ") <> -1 )
		_s = _s.replace("  ", " ")
	Wend
EndFunction

Function PercentRoll:Int(N:Int)
	N = LimitInt(N, 1, 100)
	Return (Rand(1, 100) < N)
EndFunction

Function LimitInt:Int(v:Int, mi:Int, ma:Int)
	if ( v < mi) then return v
	if ( v > ma) then return v
	return v
EndFunction
